﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using TrainCrew;

namespace SimpleSample
{
    public partial class Form1 : Form
    {
        Timer timer;
        StringBuilder sb = new StringBuilder();

        public Form1()
        {
            InitializeComponent();
            FormClosing += Form1_FormClosing;

            //Initialization. Only this function is needed to initialize TrainCrewInput.dll
            TrainCrewInput.Init();


            timer = new Timer();
            timer.Tick += Timer_Tick;
            timer.Interval = 200;
            timer.Start();
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            var state = TrainCrewInput.GetTrainState();

            sb.Clear();
            sb.AppendLine("Speed:" + state.Speed.ToString("0.0km/h"));
            sb.AppendLine("Door close:" + state.AllClose);

            label1.Text = sb.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Button b = (Button)sender;

            switch (b.Text)
            {
                case "EB": TrainCrewInput.SetNotch(-8); break;
                case "B6": TrainCrewInput.SetNotch(-7); break;
                case "B5": TrainCrewInput.SetNotch(-6); break;
                case "B4": TrainCrewInput.SetNotch(-5); break;
                case "B3": TrainCrewInput.SetNotch(-4); break;
                case "B2": TrainCrewInput.SetNotch(-3); break;
                case "B1": TrainCrewInput.SetNotch(-2); break;
                case "Holding braking":
                case "抑速":
                    TrainCrewInput.SetNotch(-1);
                    break;
                case "N": TrainCrewInput.SetNotch(0); break;
                case "P1": TrainCrewInput.SetNotch(1); break;
                case "P2": TrainCrewInput.SetNotch(2); break;
                case "P3": TrainCrewInput.SetNotch(3); break;
                case "P4": TrainCrewInput.SetNotch(4); break;
                case "P5": TrainCrewInput.SetNotch(5); break;

                case "Forward": TrainCrewInput.SetReverser(1); break;
                case "Neutral": TrainCrewInput.SetReverser(0); break;
                case "Backward": TrainCrewInput.SetReverser(-1); break;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            TrainCrewInput.Dispose();
        }
    }
}
